
#ifndef __CASL_H__
#define __CASL_H__

#ifdef __cplusplus
extern "C" {
#endif

//---------------------------------------------------------------------------
#define CASL_WORD_LENGTH			6
#define CASL_LINE_LENGTH			32

#define CASL_MAX_LINE_CNT			32
#define CASL_MAX_DRAW_LINE_CNT		12
#define CASL_MAX_LABEL_KEYWORD_CNT	7
#define CASL_MAX_OP_KEYWORD_CNT		34
#define CASL_MAX_R_KEYWORD_CNT		8
#define CASL_MAX_ADR_KEYWORD_CNT	11
#define CASL_MAX_X_KEYWORD_CNT		7
#define CASL_MAX_NUM_KEYWORD_CNT	4

#define CURSOR_BLINK_TIME			600		//J[\̓_ł̊Ԋu
#define CURSOR_FILL_TILENO			516
#define CURSOR_CLS_TILENO			512
#define CURSOR_MOVE_X_CNT			6


//---------------------------------------------------------------------------
#define OP_TYPE1					1		//none
#define OP_TYPE2					2		//r, adr ,xAr1, r2
#define OP_TYPE3					3		//r, adr ,x
#define OP_TYPE4					4		//adr ,x
#define OP_TYPE5					5		//r
#define OP_TYPE6					6		//AZu START
#define OP_TYPE7					7		//AZu END
#define OP_TYPE8					8		//AZu DS
#define OP_TYPE9					9		//AZu DC
#define OP_TYPE10					10		//}N     IN
#define OP_TYPE11					11		//}N     OUT
#define OP_TYPE12					12		//}N     RPUSH
#define OP_TYPE13					13		//}N     RPOP


//---------------------------------------------------------------------------

typedef struct {
	u8 str[CASL_LINE_LENGTH];				//\p̕
	u8 opType;								//߂̏
	u8 lblCnt;								//x̑Iԍ
	u8 opCnt;								//߂̑Iԍ
	u8 param[3];							//param̑Iԍ
} ST_CASL_LINE;


typedef struct {
	ST_CASL_LINE line[CASL_MAX_LINE_CNT];
	u16 startLine;							//\̋N_sԍ
} ST_CASL;


typedef struct {
	u8 word[CASL_WORD_LENGTH];
} ST_CASL_LABEL_KEYWORD;


typedef struct {
	u8 word[CASL_WORD_LENGTH];				//\̖O
	u8 opType;
	u8 opCode;
} ST_CASL_OP_KEYWORD;


typedef struct {
	u8 word[CASL_WORD_LENGTH];
} ST_CASL_R_KEYWORD;


typedef struct {
	u8 word[CASL_WORD_LENGTH];
} ST_CASL_ADR_KEYWORD;


typedef struct {
	u8 word[CASL_WORD_LENGTH];
} ST_CASL_X_KEYWORD;


typedef struct {
	u8 word[CASL_WORD_LENGTH];
} ST_CASL_NUM_KEYWORD;


typedef struct {
	u8   x;
	u8   y;									//\̍s
	u8   wy;								//̍s
	u8   cx;
	u8   cy;
	s16  minX;								//ړ
	s16  maxX;
	s16  minY;
	s16  maxY;
	u16  sprNo;
	u16  sprTile;
	u16  sprSize;
	u16  sprForm;
	u16  key;								//ړp
	bool blinkFlag;							//_ŗp̃tO
	u8   selPoint;							//I
} ST_CURSOR;

//---------------------------------------------------------------------------

EWRAM_CODE void CaslInit();
EWRAM_CODE void CaslInitLine(u8 wy);
EWRAM_CODE void CaslEdit();
EWRAM_CODE void CaslEditWordInsert();
EWRAM_CODE void CaslEditWordInsertLabel();
EWRAM_CODE void CaslEditWordInsertOp();
EWRAM_CODE void CaslEditWordInsertParam1();
EWRAM_CODE void CaslEditWordInsertParam2();
EWRAM_CODE void CaslEditWordInsertParam3();
EWRAM_CODE void CaslEditWordInsertR();
EWRAM_CODE void CaslEditWordInsertAdr();
EWRAM_CODE void CaslEditWordInsertRorAdr();
EWRAM_CODE void CaslEditWordInsertX();
EWRAM_CODE void CaslEditWordInsertNum();
EWRAM_CODE void CaslEditWordDelete();
EWRAM_CODE void CaslEditLineInsert();
EWRAM_CODE void CaslEditLineDelete();

EWRAM_CODE bool CaslScroll();
EWRAM_CODE void CaslDrawLine(u8 wy);
EWRAM_CODE void CaslDrawLineAll();
EWRAM_CODE void CaslDrawLineNum();

EWRAM_CODE bool CaslIsSelectPoint(u8 wy, u8 xSelCnt);

EWRAM_CODE u8   CaslGetMaxSelectPoint(u8 wy);
EWRAM_CODE u8   CaslGetRevisionSelectPoint(u8 wy);
EWRAM_CODE u8*  CaslGetRevisionStrComma(u8* dst, u8* src);

EWRAM_CODE void CaslSaveSRAM();
EWRAM_CODE void CaslLoadSRAM();

EWRAM_CODE u8*  CaslStrcpy(u8* ret, u8* s2);


//----
EWRAM_CODE void CursorInit();
EWRAM_CODE void CursorInput();
EWRAM_CODE bool CursorMove();
EWRAM_CODE void CursorDraw();
EWRAM_CODE void CursorDrawBlink();
EWRAM_CODE void CursorDrawPointNum();


#ifdef __cplusplus
}
#endif
#endif

